var path = require('path')
var fse = require('fs-extra')
const utils = require('./util')
const createStylefromCode = utils.createStylefromCode
const convertStylesToRNCSS = utils.convertStylesToRNCSS

var cwd = process.cwd()


function defaultResolve(src, file) {
    return path.resolve(path.dirname(file), src)
}


var resolve
function main(opt) {
    var t = opt.types
    var template = opt.template

    return {
        manipulateOptions: function (rp) {
            var resolveModuleSource = rp.resolveModuleSource
            resolve =  resolveModuleSource || defaultResolve
        },

        visitor: {
            ImportDeclaration: {
                exit: function (curPath, state) {
                    var opts = state.opts
                    var file = state.file


                    var importPath = curPath.node.source.value
                    var jsFilename = file.opts.filename

                    if (importPath.endsWith('.wxss')) {
                        // Find the file, using node resolution/NODE_PATH if necessary.

                        const env = process.env.BABEL_ENV || process.env.NODE_ENV || 'development'
                        if (env === 'development') {
                            devHandler(curPath, importPath, jsFilename)
                        } else {
                            prodHandler(curPath, opts, importPath, jsFilename, template, t)
                        }
                    }
                }
            }
        }
    }
}

function devHandler(curPath, importPath, jsFilename) {
    var absPath = resolve(importPath, jsFilename)

    var projectDir = path.resolve(require.resolve('./index.js'), '..', '..', '..', '..')

    absPath = absPath.replace(projectDir, 'babel-plugin-import-wxss/rncsscache')
    curPath.node.source.value = (absPath + '.js')
}

function prodHandler(curPath, opts, importPath, jsFilename, template, t){
    var absPath = resolve(importPath, jsFilename)

    let cssStr = ""
    if (fse.existsSync(absPath)) {
        cssStr = fse.readFileSync(absPath).toString()
    }
    let cssObj = convertStylesToRNCSS(createStylefromCode(cssStr,absPath))

    var defautIdenti = curPath.node.specifiers[0].local.name
    const buildNode = template('const STYLES = STYOBJ;', { sourceType: 'module' })
    const styleExpre = buildNode({
        STYLES: t.identifier(defautIdenti),
        STYOBJ: t.identifier(cssObj)
    })

    curPath.replaceWith(styleExpre)
}

module.exports = main